package cn.estsh.i3plus.core.api.iservice.busi;

import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.platform.bean.SysTool;
import io.swagger.annotations.ApiOperation;

import java.util.List;

/**
 * @Description : 硬件服务接口
 * @Reference :
 * @Author : yunhao
 * @Date : 2018-10-25 20:20
 * @Modify :
 **/
public interface ISysToolService {

    /**
     * 添加硬件
     * @param tool
     */
    @ApiOperation(value = "新增硬件信息")
    SysTool insertSysTool(SysTool tool);

    /**
     * 修改硬件
     * @param tool
     */
    @ApiOperation(value = "更新硬件信息")
    void updateSysTool(SysTool tool);

    /**
     * 修改硬件
     */
    @ApiOperation(value = "造数据")
    void insertBatch(int num,int waitTime);

    /**
     * 查找全部硬件
     * @return
     */
    @ApiOperation(value = "查询设备信息",notes = "查询所有设备信息")
    List<SysTool> listSysTool();

    /**
     * 根据id查找硬件
     * @param id
     * @return
     */
    @ApiOperation(value = "查询设备信息",notes = "根据ID 查询设备信息")
    SysTool getSysToolById(Long id);

    /**
     * 硬件复杂查询，分页，排序
     * @param tool
     * @param pager
     * @return
     */
    @ApiOperation(value = "查询设备信息",notes = "根据条件 查询设备信息(分页)")
    ListPager querySysToolByPager(SysTool tool, Pager pager);

    /**
     * 根据id修改硬件状态
     * @param id
     * @param status
     */
    @ApiOperation(value = "更新设备信息",notes = "更新设备状态信息")
    void updateSysToolStatusById(Long id,Integer status);

    /**
     * 删除硬件
     * @param id
     */
    @ApiOperation(value = "删除硬件信息",notes = "根据 ID 删除硬件信息")
    int deleteSysToolById(Long id);

    /**
     * 批量删除硬件
     * @param ids
     */
    @ApiOperation(value = "删除硬件信息",notes = "根据 ID 批量删除硬件信息")
    int deleteSysToolByIds(Long[] ids);

    /**
     * 批量修改硬件状态
     * @param ids
     * @param status
     */
    @ApiOperation(value = "更新设备信息",notes = "根据 ID 批量修改硬件状态信息")
    int updateSysToolStatusByIds(Long[] ids,Integer status);

    /**
     * 压力测试
     * 查询指定数量设备信息
     */
    @ApiOperation(value = "查询指定数量设备信息",notes = "查询指定数量设备信息")
    List<SysTool> findSysToolByTop(int topNum);

    /**
     * 压力测试
     * @param min
     * @param max
     * @return
     */
    @ApiOperation(value = "查询指定数量设备信息",notes = "查询指定数量设备信息")
    List<SysTool> findSysToolByIdInterval(long min,long max);
}
